//+--------------------------------------------------------------------------------------------------------------------------------------+
//|                                                                                                                    i-Sessions.mq4    |
//|                                                                                                              . aka KimIV    |
//|                                                                                                               http://www.kimiv.ru    | 
//|                                                                                  "OZ"  finansovyj-dozor.narod.ru   |
//|16.11.2005         .                                                                  |
//|   M15-1  8          ( )              |
//|     - 6.00.                                                  |
//|                                                                                     |
//|   ,    ,                                                            |
//|              ()                  |
//|   ,  ..     ...   extern int    NumberOfDays = 20;//                        |
//+--------------------------------------------------------------------------------------------------------------------------------------+
#property copyright "  . aka KimIV" 
#property link      "http://www.kimiv.ru" 

#property indicator_chart_window

//-------    -------------------------------
extern string Zametka1 = "   ,  2           .       - Rectangle-     63 .       . ";
extern string Zametka2 = "                 ";
extern string Zametka3 = "          -       ";

                                       //   - White -       ,      

extern int    NumberOfDays = 20;//5;//292;//92;         //  
extern string AsiaBegin    = "06:00";   //                             
extern string AsiaEnd      = "10:00";   //           
extern color  AsiaColor    = Teal;    //   
extern string EurBegin     = "11:00";   //     10.00   1   
extern string EurEnd       = "16:00";   //   
extern color  EurColor     = Green;       //   
extern string OZ1Begin     = "00:15";     // 1-      
extern string OZ1End       = "03:00";     //     25   
extern color  OZ1Color     = Magenta;     //        N1
extern string OZ2Begin     = "00:15";     // 2-      
extern string OZ2End       = "05:00";     //     25   
extern color  OZ2Color     = Orange;     //        2

extern string OZ3Begin     = "00:01";     //  
extern string OZ3End       = "23:59";     //   
extern color  OZ3Color     = EMPTY;//Violet;//EMPTY;//Navy;     //       -   Gold      !!!!!!!
extern string OZ301Begin     = "00:01";     //  
extern string OZ301End       = "23:59";     //   
extern color  OZ301Color     = EMPTY;//Violet;//EMPTY;//Navy;     //       -   Gold      !!!!!!!

//  OZ-    8-        -    
//       8-   -      ???

extern string OZ4Begin     = "20:00";     // 4-  -     -   
extern string OZ4End       = "22:30";     //   
extern color  OZ4Color     = Indigo;     //    N4
extern string USABegin     = "17:30";   //      1     
extern string USAEnd       = "22:30";   //       N5
extern color  USAColor     = Brown;      //       N5
extern bool   ShowPrice    = True;      //   
extern color  clFont       = Red;//Olive;//White;//Indigo;      //  
extern int    SizeFont     = 8;         //  
//extern int    OffSetUp     = 22;       //  
//extern int    OffSetDn     = 3;        //  
extern double    Up     = 7.5;                                 //     
extern double    Dn     = 1.7;        //  

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void init() 
{
  DeleteObjects();
  for (int i=0; i<NumberOfDays; i++) 
  {
    CreateObjects("AS"+i, AsiaColor);
    CreateObjects("EU"+i, EurColor);
    CreateObjects("OZ1"+i, OZ1Color);
    CreateObjects("OZ2"+i, OZ2Color);
    CreateObjects("OZ3"+1, OZ3Color);//  1  i      
    
    CreateObjects("OZ301"+2, OZ301Color);//  i  2          2 
    
    //CreateObjects("OZ32"+3, OZ302Color);//  1  i      
    
    CreateObjects("OZ4"+i, OZ4Color);
    CreateObjects("US"+i, USAColor);
  } 
  Comment("");
}

//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
void deinit() 
{
  DeleteObjects();
  Comment("");
}

//+------------------------------------------------------------------+
//|                                        |
//| :                                                       |
//|   no -                                        |
//|   cl -                                                |
//+------------------------------------------------------------------+
void CreateObjects(string no, color cl) 
{
  ObjectCreate(no, OBJ_RECTANGLE, 0, 0,0, 0,0);
  ObjectSet(no, OBJPROP_STYLE, STYLE_SOLID);
  ObjectSet(no, OBJPROP_COLOR, cl);
  ObjectSet(no, OBJPROP_BACK, True);
}

//+------------------------------------------------------------------+
//|                                        |
//+------------------------------------------------------------------+
void DeleteObjects() 
{
  for (int i=0; i<NumberOfDays; i++) 
  {
    ObjectDelete("AS"+i);
    ObjectDelete("EU"+i);
    ObjectDelete("OZ1"+i);
    ObjectDelete("OZ2"+i);
    ObjectDelete("OZ3"+i);
    ObjectDelete("OZ301"+i);
    
    ObjectDelete("OZ4"+i);
    ObjectDelete("US"+i);
  }
  ObjectDelete("ASup");
  ObjectDelete("ASdn"); 
  ObjectDelete("ASmiddle");
  
  ObjectDelete("EUup");
  ObjectDelete("EUdn");
  ObjectDelete("EUmiddle");
  
  ObjectDelete("OZ1up");
  ObjectDelete("OZ1dn");
  ObjectDelete("OZ1middle");
  
  ObjectDelete("OZ2up");
  ObjectDelete("OZ2dn");  
  ObjectDelete("OZ2middle");
  
  ObjectDelete("OZ3up");
  ObjectDelete("OZ3dn"); 
  ObjectDelete("OZ3middle");
  
  ObjectDelete("OZ301up");
  ObjectDelete("OZ301dn"); 
  ObjectDelete("OZ301middle");
  
  
  ObjectDelete("OZ4up");
  ObjectDelete("OZ4dn");
  ObjectDelete("OZ4middle");
  
  ObjectDelete("USup");
  ObjectDelete("USdn");
  ObjectDelete("USmiddle");

}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
void start() {
  datetime dt=CurTime();

  for (int i=0; i<NumberOfDays; i++) 
   {
    if (ShowPrice && i==0) 
      {                   // - 3-  -      -   -  
      DrawPrices(dt, "AS", AsiaBegin, AsiaEnd);
      }
    if (ShowPrice && i==0) 
      {                   // -   -       
      DrawPrices(dt, "EU", EurBegin, EurEnd);
      }
    if (ShowPrice && i==1) 
      {                   // - 1-   - 1-   -        
      DrawPrices(dt, "OZ1", OZ1Begin, OZ1End);
      }
    if (ShowPrice && i==0) 
      {                   // -   - 2-   -      -   
      DrawPrices(dt, "OZ2", OZ2Begin, OZ2End);
      }
    if (ShowPrice && i==1) 
      {                   // -  1      H-L
      DrawPrices(dt, "OZ3", OZ3Begin, OZ3End);
      }
      
    if (ShowPrice && i==2) 
      {                   // -  2    H-L 2-  
      DrawPrices(dt, "OZ301", OZ301Begin, OZ301End);                                      // !!!
      }
      
    if (ShowPrice && i==0) 
      {                   // -   -     
       DrawPrices(dt, "OZ4", OZ4Begin, OZ4End);
      }
    if (ShowPrice && i==0) 
      {                   // -          (  KREST  4EREPUGI)
      DrawPrices(dt, "US", USABegin, USAEnd);
   }
    DrawObjects(dt, "AS" +i, AsiaBegin, AsiaEnd);
    DrawObjects(dt, "EU" +i, EurBegin, EurEnd);
    DrawObjects(dt, "OZ1"+i, OZ1Begin, OZ1End);
    DrawObjects(dt, "OZ2"+i, OZ2Begin, OZ2End);
    DrawObjects(dt, "OZ3"+i, OZ3Begin, OZ3End);
    
    DrawObjects(dt, "OZ301"+i, OZ301Begin, OZ301End);                                    // !!!
    
    DrawObjects(dt, "OZ4"+i, OZ4Begin, OZ4End);
    DrawObjects(dt, "US" +i, USABegin, USAEnd);
    dt=decDateTradeDay(dt);
    while (TimeDayOfWeek(dt)>5) dt=decDateTradeDay(dt);
  }
}

//+------------------------------------------------------------------+
//|                                       |
//| :                                                       |
//|   dt -                                           |
//|   no -                                        |
//|   tb -                                          |
//|   te -                                       |
//+------------------------------------------------------------------+
void DrawObjects(datetime dt, string no, string tb, string te) 
{
  datetime t1, t2;
  double   p1, p2;
  int      b1, b2;

  t1=StrToTime(TimeToStr(dt, TIME_DATE)+" "+tb);
  t2=StrToTime(TimeToStr(dt, TIME_DATE)+" "+te);
  
  b1=iBarShift(NULL, 0, t1);
  b2=iBarShift(NULL, 0, t2);
  
  p1=High[Highest(NULL, 0, MODE_HIGH, b1-b2, b2)];
  p2=Low [Lowest (NULL, 0, MODE_LOW , b1-b2, b2)];

  ObjectSet(no, OBJPROP_TIME1 , t1);
  ObjectSet(no, OBJPROP_PRICE1, p1);
  ObjectSet(no, OBJPROP_TIME2 , t2);
  ObjectSet(no, OBJPROP_PRICE2, p2);
}

//+------------------------------------------------------------------+
//|                                   |
//| :                                                       |
//|   dt -                                           |
//|   no -                                        |
//|   tb -                                          |
//|   te -                                       |
//+------------------------------------------------------------------+
void DrawPrices(datetime dt, string no, string tb, string te) 
{
  datetime t1, t2;
  double   p1, p2;
  int      b1, b2;
 
  t1=StrToTime(TimeToStr(dt, TIME_DATE)+" "+tb);
  t2=StrToTime(TimeToStr(dt, TIME_DATE)+" "+te);
  
  b1=iBarShift(NULL, 0, t1);
  b2=iBarShift(NULL, 0, t2);
  
  p1=High[Highest(NULL, 0, MODE_HIGH, b1-b2, b2)];
  p2=Low [Lowest (NULL, 0, MODE_LOW , b1-b2, b2)];
 
  if (ObjectFind(no+"up")<0) ObjectCreate(no+"up", OBJ_TEXT, 0, 0,0);
  ObjectSet(no+"up", OBJPROP_TIME1   , t2);
  ObjectSet(no+"up", OBJPROP_PRICE1  , p1+(Ask-Bid)*Up);//+OffSetUp*Point);//   -   
  ObjectSet(no+"up", OBJPROP_COLOR   , clFont);
  ObjectSet(no+"up", OBJPROP_FONTSIZE, SizeFont);
  ObjectSetText(no+"up", DoubleToStr(p1, Digits));

  if (ObjectFind(no+"dn")<0) ObjectCreate(no+"dn", OBJ_TEXT, 0, 0,0);
  ObjectSet(no+"dn", OBJPROP_TIME1   , t2);
  ObjectSet(no+"dn", OBJPROP_PRICE1  , p2-(Ask-Bid)*Dn);//-OffSetDn*Point);//  
  ObjectSet(no+"dn", OBJPROP_COLOR   , clFont);
  ObjectSet(no+"dn", OBJPROP_FONTSIZE, SizeFont);
  ObjectSetText(no+"dn", DoubleToStr(p2, Digits));
}

//+------------------------------------------------------------------+
//|                                  |
//| :                                                       |
//|   dt -                                           |
//+------------------------------------------------------------------+
datetime decDateTradeDay (datetime dt) 
{
  int ty=TimeYear(dt);
  int tm=TimeMonth(dt);
  int td=TimeDay(dt);
  int th=TimeHour(dt);
  int ti=TimeMinute(dt);

  td--;
  if (td==0) 
  {
    tm--;
    if (tm==0) 
    {
      ty--;
      tm=12;
    }
    if (tm==1 || tm==3 || tm==5 || tm==7 || tm==8 || tm==10 || tm==12) td=31;
    if (tm==2) if (MathMod(ty, 4)==0) td=29; else td=28;
    if (tm==4 || tm==6 || tm==9 || tm==11) td=30;
  }
  return(StrToTime(ty+"."+tm+"."+td+" "+th+":"+ti));
}
//+------------------------------------------------------------------+

